"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.placeKindAndBookOpToPlaceOperation = exports.bookTypeToPlaceKind = void 0;
const constants_1 = require("./constants");
// from the Company perspective
exports.bookTypeToPlaceKind = {
    // obviously an asset
    [constants_1.BOOK_PAYINS_AUTHOR]: 'asset',
    [constants_1.BOOK_PAYINS_ENJOYER]: 'asset',
    // the refund is done against company assets
    [constants_1.BOOK_REFUNDS_AUTHOR]: 'asset',
    [constants_1.BOOK_REFUNDS_ENJOYER]: 'asset',
    // the payout is done from company assets
    [constants_1.BOOK_PAYOUTS_AUTHOR]: 'asset',
    [constants_1.BOOK_PAYOUTS_ENJOYER]: 'asset',
    // we're still about to pay it
    [constants_1.BOOK_QUEUED_AUTHOR]: 'liability',
    // what was taken from them
    [constants_1.BOOK_DEPRIVATIONS_AUTHOR]: 'asset',
    [constants_1.BOOK_PROVIDER_CONVERSION_AUTHOR]: 'asset',
    // we are liable to pay those out at some point
    [constants_1.BOOK_PENDING_AUTHOR]: 'liability',
    [constants_1.BOOK_PENDING_ENJOYER]: 'liability',
};
exports.placeKindAndBookOpToPlaceOperation = {
    asset: {
        debit: 'increase',
        credit: 'decrease',
    },
    liability: {
        debit: 'decrease',
        credit: 'increase',
    },
};
var JournalEntryIdBrand;
(function (JournalEntryIdBrand) {
    JournalEntryIdBrand["_"] = "";
})(JournalEntryIdBrand || (JournalEntryIdBrand = {}));
var BookEntryIdBrand;
(function (BookEntryIdBrand) {
    BookEntryIdBrand["_"] = "";
})(BookEntryIdBrand || (BookEntryIdBrand = {}));
var ShelfIdBrand;
(function (ShelfIdBrand) {
    ShelfIdBrand["_"] = "";
})(ShelfIdBrand || (ShelfIdBrand = {}));
var BookIdBrand;
(function (BookIdBrand) {
    BookIdBrand["_"] = "";
})(BookIdBrand || (BookIdBrand = {}));
