"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CURRENCIES = exports.SPECIAL_CURRENCIES_S = exports.SPECIAL_CURRENCIES = exports.ZERO_DECIMAL_CURRENCIES_S = exports.ZERO_DECIMAL_CURRENCIES = exports.DEFAULT_CURRENCY = exports.usd = exports.EUR = exports.USD = void 0;
// inner representation is uppercase (i.e. dinero)
exports.USD = 'USD';
exports.EUR = 'EUR';
// sometimes, the requirement is lowercase (stripe)
exports.usd = 'usd';
exports.DEFAULT_CURRENCY = exports.USD;
// TODO very likely Dinero is enough
// https://stripe.com/docs/currencies#zero-decimal
exports.ZERO_DECIMAL_CURRENCIES = [
    'BIF',
    'PYG',
    'CLP',
    'RWF',
    'DJF',
    'UGX',
    'GNF',
    'VND',
    'JPY',
    'VUV',
    'KMF',
    'XAF',
    'KRW',
    'XOF',
    'MGA',
    'XPF',
];
exports.ZERO_DECIMAL_CURRENCIES_S = new Set(exports.ZERO_DECIMAL_CURRENCIES);
// TODO https://stripe.com/docs/currencies#special-cases
exports.SPECIAL_CURRENCIES = ['HUF', 'TWD', 'UGX'];
exports.SPECIAL_CURRENCIES_S = new Set(exports.SPECIAL_CURRENCIES);
exports.CURRENCIES = [
    'AED',
    'AFN',
    'ALL',
    'AMD',
    'ANG',
    'AOA',
    'ARS',
    'AUD',
    'AWG',
    'AZN',
    'BAM',
    'BBD',
    'BDT',
    'BGN',
    'BHD',
    'BMD',
    'BND',
    'BOB',
    'BOV',
    'BRL',
    'BSD',
    'BTN',
    'BWP',
    'BYN',
    'BZD',
    'CAD',
    'CDF',
    'CHE',
    'CHF',
    'CHW',
    'CLF',
    'CNY',
    'COP',
    'COU',
    'CRC',
    'CUC',
    'CUP',
    'CVE',
    'CZK',
    'DKK',
    'DOP',
    'DZD',
    'EGP',
    'ERN',
    'ETB',
    'EUR',
    'FJD',
    'FKP',
    'GBP',
    'GEL',
    'GHS',
    'GIP',
    'GMD',
    'GTQ',
    'GYD',
    'HKD',
    'HNL',
    'HRK',
    'HTG',
    'IDR',
    'ILS',
    'INR',
    'IQD',
    'IRR',
    'ISK',
    'JMD',
    'JOD',
    'KES',
    'KGS',
    'KHR',
    'KPW',
    'KWD',
    'KYD',
    'KZT',
    'LAK',
    'LBP',
    'LKR',
    'LRD',
    'LSL',
    'LYD',
    'MAD',
    'MDL',
    'MKD',
    'MMK',
    'MNT',
    'MOP',
    'MRU',
    'MUR',
    'MVR',
    'MWK',
    'MXN',
    'MXV',
    'MYR',
    'MZN',
    'NAD',
    'NGN',
    'NIO',
    'NOK',
    'NPR',
    'NZD',
    'OMR',
    'PAB',
    'PEN',
    'PGK',
    'PHP',
    'PKR',
    'PLN',
    'QAR',
    'RON',
    'RSD',
    'RUB',
    'SAR',
    'SBD',
    'SCR',
    'SDG',
    'SEK',
    'SGD',
    'SHP',
    'SLL',
    'SOS',
    'SRD',
    'SSP',
    'STN',
    'SVC',
    'SYP',
    'SZL',
    'THB',
    'TJS',
    'TMT',
    'TND',
    'TOP',
    'TRY',
    'TTD',
    'TZS',
    'UAH',
    exports.USD,
    'USN',
    'UYI',
    'UYU',
    'UYW',
    'UZS',
    'VES',
    'WST',
    'XAG',
    'XAU',
    'XBA',
    'XBB',
    'XBC',
    'XBD',
    'XCD',
    'XDR',
    'XPD',
    'XPT',
    'XSU',
    'XTS',
    'XUA',
    'XXX',
    'YER',
    'ZAR',
    'ZMW',
    'ZWL',
    ...exports.ZERO_DECIMAL_CURRENCIES,
    ...exports.SPECIAL_CURRENCIES.filter((c) => c !== 'UGX'),
];
