"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parsers_common_1 = require("./parsers.common");
describe('common parsers', () => {
    describe('id parsers', () => {
        it('should parse valid complext ids', () => {
            const src = 'user::123';
            const dst = 'channel::456';
            const srcSerializedParsed = parsers_common_1.payinApiSrcSerializedParser.parse(src);
            const dstSerializedParsed = parsers_common_1.payinApiDstSerializedParser.parse(dst);
            expect(srcSerializedParsed).toBe(src);
            expect(dstSerializedParsed).toBe(dst);
            const srcO = parsers_common_1.payinApiSrcCompositeParser.parse(src);
            const dstO = parsers_common_1.payinApiDstCompositeParser.parse(dst);
            expect(srcO).toEqual({
                type: 'user',
                id: '123',
            });
            expect(dstO).toEqual({
                type: 'channel',
                id: '456',
            });
        });
    });
});
