import { z } from 'zod';
export declare const payinMethodOriginIdParser: z.ZodEffects<z.ZodEffects<z.ZodString, import("../stripe/types").StripePaymentMethodIdBrand, string>, import("../stripe/types").StripePaymentMethodIdBrand, string>;
export declare const payinMethodOriginTypeParser: z.ZodEnum<["stripe", "paypal"]>;
export declare const payinMethodUpsertResultParser: z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, import("../stripe/types").StripeCustomerIdBrand, string>, z.ZodLiteral<"paypal">]>, import("../stripe/types").StripeCustomerIdBrand | "paypal", string>;
export declare const payinMethodListResultParser: z.ZodArray<z.ZodDiscriminatedUnion<"originType", [z.ZodObject<{
    originType: z.ZodLiteral<"stripe">;
    originId: z.ZodEffects<z.ZodString, import("../stripe/types").StripePaymentMethodIdBrand, string>;
    originData: z.ZodObject<{
        id: z.ZodEffects<z.ZodString, import("../stripe/types").StripePaymentMethodIdBrand, string>;
        object: z.ZodLiteral<"payment_method">;
        customer: z.ZodNullable<z.ZodEffects<z.ZodString, import("../stripe/types").StripeCustomerIdBrand, string>>;
        billing_details: z.ZodObject<{
            address: z.ZodNullable<z.ZodObject<{
                city: z.ZodNullable<z.ZodString>;
                country: z.ZodNullable<z.ZodString>;
                line1: z.ZodNullable<z.ZodString>;
                line2: z.ZodNullable<z.ZodString>;
                postal_code: z.ZodNullable<z.ZodString>;
                state: z.ZodNullable<z.ZodString>;
            }, "strip", z.ZodTypeAny, {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            }, {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            }>>;
            email: z.ZodNullable<z.ZodString>;
            name: z.ZodNullable<z.ZodString>;
            phone: z.ZodNullable<z.ZodString>;
        }, "strip", z.ZodTypeAny, {
            email: string | null;
            address: {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            } | null;
            name: string | null;
            phone: string | null;
        }, {
            email: string | null;
            address: {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            } | null;
            name: string | null;
            phone: string | null;
        }>;
        created: z.ZodNumber;
        metadata: z.ZodNullable<z.ZodObject<{}, "strip", z.ZodTypeAny, {}, {}>>;
        card: z.ZodOptional<z.ZodObject<{
            brand: z.ZodString;
            last4: z.ZodString;
        }, "strip", z.ZodTypeAny, {
            brand: string;
            last4: string;
        }, {
            brand: string;
            last4: string;
        }>>;
    }, "strip", z.ZodTypeAny, {
        card?: {
            brand: string;
            last4: string;
        } | undefined;
        object: "payment_method";
        id: import("../stripe/types").StripePaymentMethodIdBrand;
        customer: import("../stripe/types").StripeCustomerIdBrand | null;
        billing_details: {
            email: string | null;
            address: {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            } | null;
            name: string | null;
            phone: string | null;
        };
        created: number;
        metadata: {} | null;
    }, {
        card?: {
            brand: string;
            last4: string;
        } | undefined;
        object: "payment_method";
        id: string;
        customer: string | null;
        billing_details: {
            email: string | null;
            address: {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            } | null;
            name: string | null;
            phone: string | null;
        };
        created: number;
        metadata: {} | null;
    }>;
}, "strip", z.ZodTypeAny, {
    originType: "stripe";
    originId: import("../stripe/types").StripePaymentMethodIdBrand;
    originData: {
        card?: {
            brand: string;
            last4: string;
        } | undefined;
        object: "payment_method";
        id: import("../stripe/types").StripePaymentMethodIdBrand;
        customer: import("../stripe/types").StripeCustomerIdBrand | null;
        billing_details: {
            email: string | null;
            address: {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            } | null;
            name: string | null;
            phone: string | null;
        };
        created: number;
        metadata: {} | null;
    };
}, {
    originType: "stripe";
    originId: string;
    originData: {
        card?: {
            brand: string;
            last4: string;
        } | undefined;
        object: "payment_method";
        id: string;
        customer: string | null;
        billing_details: {
            email: string | null;
            address: {
                city: string | null;
                country: string | null;
                line1: string | null;
                line2: string | null;
                postal_code: string | null;
                state: string | null;
            } | null;
            name: string | null;
            phone: string | null;
        };
        created: number;
        metadata: {} | null;
    };
}>, z.ZodObject<{
    originType: z.ZodLiteral<"paypal">;
    originId: z.ZodString;
}, "strip", z.ZodTypeAny, {
    originType: "paypal";
    originId: string;
}, {
    originType: "paypal";
    originId: string;
}>]>, "many">;
export declare const payinMethodUpsertParamsParser: z.ZodDiscriminatedUnion<"originType", [z.ZodObject<{
    originId: z.ZodEffects<z.ZodString, import("../stripe/types").StripePaymentMethodIdBrand, string>;
    originType: z.ZodLiteral<"stripe">;
}, "strip", z.ZodTypeAny, {
    originType: "stripe";
    originId: import("../stripe/types").StripePaymentMethodIdBrand;
}, {
    originType: "stripe";
    originId: string;
}>, z.ZodObject<{
    originId: z.ZodString;
    originType: z.ZodLiteral<"paypal">;
}, "strip", z.ZodTypeAny, {
    originType: "paypal";
    originId: string;
}, {
    originType: "paypal";
    originId: string;
}>]>;
export declare const payinMethodDeleteParamsParser: z.ZodDiscriminatedUnion<"originType", [z.ZodObject<{
    originId: z.ZodEffects<z.ZodString, import("../stripe/types").StripePaymentMethodIdBrand, string>;
    originType: z.ZodLiteral<"stripe">;
}, "strip", z.ZodTypeAny, {
    originType: "stripe";
    originId: import("../stripe/types").StripePaymentMethodIdBrand;
}, {
    originType: "stripe";
    originId: string;
}>, z.ZodObject<{
    originId: z.ZodString;
    originType: z.ZodLiteral<"paypal">;
}, "strip", z.ZodTypeAny, {
    originType: "paypal";
    originId: string;
}, {
    originType: "paypal";
    originId: string;
}>]>;
export declare const payinMethodListQueryParser: z.ZodObject<{
    limit: z.ZodEffects<z.ZodEffects<z.ZodUnion<[z.ZodNumber, z.ZodEffects<z.ZodString, number, string>]>, number, string | number>, number, string | number>;
}, "strip", z.ZodTypeAny, {
    limit: number;
}, {
    limit: string | number;
}>;
