import { PAYIN_METHOD_ORIGIN_TYPES } from './constants';
import { StripePayinMethodId } from '../stripe/types';
import { ORIGIN_TYPE_PAYPAL, ORIGIN_TYPE_STRIPE } from '../origin/constants';
import { PayinProviderOriginType } from '../payinProvider/types';
import { PaypalPayinMethodId } from '../paypal/types';
export type PayinMethodOriginType = typeof PAYIN_METHOD_ORIGIN_TYPES[number];
export type PayinMethodOriginId<PP extends PayinProviderOriginType = typeof ORIGIN_TYPE_STRIPE> = PP extends typeof ORIGIN_TYPE_STRIPE ? StripePayinMethodId : PP extends typeof ORIGIN_TYPE_PAYPAL ? PaypalPayinMethodId : never;
type PayinMethodOriginIdOfTypeMapping = {
    [ORIGIN_TYPE_PAYPAL]: never;
    [ORIGIN_TYPE_STRIPE]: StripePayinMethodId;
};
export type PayinMethodOriginIdOfType<T extends PayinMethodOriginType> = PayinMethodOriginIdOfTypeMapping[T];
export {};
