"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.payoutConversionProviderItemCompositeKeyIsomorphism = exports.SEPARATOR = void 0;
const isomorphism_1 = require("../../isomorphism");
const omit_1 = __importDefault(require("lodash/omit"));
const parsers_common_1 = require("./parsers.common");
exports.SEPARATOR = isomorphism_1.SEPARATOR;
exports.payoutConversionProviderItemCompositeKeyIsomorphism = {
    to: ({ userId, originTypeFrom, currency, originTypeTo }) => `${isomorphism_1.payoutBatchItemCompositeKeyIsomorphism.to({
        userId,
        originType: originTypeFrom,
        currency,
    })}${exports.SEPARATOR}${originTypeTo}`,
    from: (serialized) => {
        const parentFields = (0, isomorphism_1.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(false)(serialized);
        const head = isomorphism_1.payoutBatchItemCompositeKeyIsomorphism.to(parentFields);
        const tail = serialized.slice(head.length + exports.SEPARATOR.length);
        return parsers_common_1.payoutConversionProviderItemCompositeKeyParser.parse({
            ...(0, omit_1.default)(parentFields, ['originType']),
            originTypeFrom: parentFields.originType,
            originTypeTo: tail,
        });
    },
};
