"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isomorphism_1 = require("./isomorphism");
describe('payoutConversionProviderItemCompositeKeyIsomorphism', () => {
    it('obeys the law', () => {
        const s = 'userId1:stripe:USD:paypal';
        const r = isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.from(s);
        expect(isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.to(r)).toEqual(s);
    });
    it('handles wrong provider from', () => {
        const s = 'userId1:elonmusk:USD:stripe';
        expect(() => isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.from(s)).toThrow('invalid_enum_value');
    });
    it('handles wrong provider tp', () => {
        const s = 'userId1:stripe:USD:elonmusk';
        expect(() => isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.from(s)).toThrow('invalid_enum_value');
    });
    it('handles wrong currency', () => {
        const s = 'userId1:stripe:CHOCOLATE:paypal';
        expect(() => isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.from(s)).toThrow('invalid_enum_value');
    });
    it('handles same provider', () => {
        const s = 'userId1:stripe:USD:stripe';
        expect(() => isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.from(s)).toThrow('originTypeFrom and originTypeTo must be different');
    });
});
