"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.payoutConversionProviderItemCompositeKeySerializedParser = void 0;
const zod_1 = __importDefault(require("zod"));
const parsers_common_1 = require("./parsers.common");
const isomorphism_1 = require("./isomorphism");
exports.payoutConversionProviderItemCompositeKeySerializedParser = zod_1.default
    .string()
    .transform((s) => isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.from(s))
    .superRefine((o, ctx) => {
    const r = parsers_common_1.payoutConversionProviderItemCompositeKeyParser.safeParse(o);
    if (!r.success)
        r.error.issues.forEach(ctx.addIssue.bind(ctx));
})
    .transform(isomorphism_1.payoutConversionProviderItemCompositeKeyIsomorphism.to);
