"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paypalMassPayoutLineNoteFullRegexS = exports.payoutBatchKeyFromPaypalMassPayoutLineNotePrefix = exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegex = exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegexStrict = exports.paypalMassPayoutLineNotePrefixRegexS = exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefix = exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END = exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START = exports.payoutBatchItemCompositeKeyNonLineableIsomorphism = exports.payoutBatchItemCompositeKeyLineableIsomorphism = exports.payoutBatchItemCompositeKeyIsomorphism = exports.shelfCompositeKeyIsomorphism = exports.parserNonLineable = exports.parserLineable = exports.parser = exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs = exports.SEPARATOR = void 0;
const parsers_common_1 = require("./parsers.common");
const constants_1 = require("./constants");
exports.SEPARATOR = ':';
const payoutBatchItemCompositeKeyIsomorphismFromParseArgs = (strict = true) => (serialized) => {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const [userId, originType, currency, ...rest] = serialized.split(exports.SEPARATOR);
    if (strict && rest.length > 0)
        throw new Error(`invalid serialized PayoutBatchItemCompositeKey: ${serialized}; extra parts: ${rest.join(exports.SEPARATOR)}`);
    return {
        userId,
        originType,
        currency,
    };
};
exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs = payoutBatchItemCompositeKeyIsomorphismFromParseArgs;
exports.parser = parsers_common_1.payoutBatchItemCompositeKeyParser;
exports.parserLineable = parsers_common_1.payoutBatchItemCompositeKeyLineGranularParser;
exports.parserNonLineable = parsers_common_1.payoutBatchItemCompositeKeyNonLineGranularParser;
exports.shelfCompositeKeyIsomorphism = {
    to: ({ userId, originType, currency }) => `${userId}${exports.SEPARATOR}${originType}${exports.SEPARATOR}${currency}`,
    from: (o) => exports.parser.parse((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true)(o)),
};
exports.payoutBatchItemCompositeKeyIsomorphism = exports.shelfCompositeKeyIsomorphism;
exports.payoutBatchItemCompositeKeyLineableIsomorphism = {
    to: (o) => {
        if (!constants_1.PAYOUT_QUEUE_LINE_GRANULAR_ORIGIN_TYPES.includes(o.originType))
            throw new Error(`invalid origin to present as a line granular key ${o.originType}`);
        return exports.payoutBatchItemCompositeKeyIsomorphism.to(o);
    },
    from: (o) => exports.parserLineable.parse((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true)(o)),
};
exports.payoutBatchItemCompositeKeyNonLineableIsomorphism = {
    to: (o) => {
        if (!constants_1.PAYOUT_QUEUE_NON_LINE_GRANULAR_ORIGIN_TYPES.includes(o.originType))
            throw new Error(`invalid origin to present as a line granular key ${o.originType}`);
        return exports.payoutBatchItemCompositeKeyIsomorphism.to(o);
    },
    from: (o) => exports.parserNonLineable.parse((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true)(o)),
};
exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START = '{';
exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END = '}';
const payoutBatchKeyToPaypalMassPayoutLineNotePrefix = (payoutBatchKey) => `${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START}${payoutBatchKey}${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END}`;
exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefix = payoutBatchKeyToPaypalMassPayoutLineNotePrefix;
exports.paypalMassPayoutLineNotePrefixRegexS = `${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START}(.+)${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END}`;
exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegexStrict = RegExp(`^${exports.paypalMassPayoutLineNotePrefixRegexS}$`);
exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegex = RegExp(`${exports.paypalMassPayoutLineNotePrefixRegexS}`);
const payoutBatchKeyFromPaypalMassPayoutLineNotePrefix = (prefix) => {
    const match = prefix.match(exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegex);
    if (!match) {
        throw new Error(`panic! Invalid prefix ${prefix}`);
    }
    return parsers_common_1.payoutBatchKeyParser.parse(match[1]);
};
exports.payoutBatchKeyFromPaypalMassPayoutLineNotePrefix = payoutBatchKeyFromPaypalMassPayoutLineNotePrefix;
exports.paypalMassPayoutLineNoteFullRegexS = `^${exports.paypalMassPayoutLineNotePrefixRegexS}(.*)$`;
