"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.payoutBatchKeyParser = exports.payoutBatchItemCompositeKeyNonLineGranularParser = exports.payoutBatchItemCompositeKeyLineGranularParser = exports.payoutBatchItemCompositeKeyParser = exports.compositeKeyNonLineGranularParsers = exports.compositeKeyLineGranularParsers = exports.compositeKeyParsers = void 0;
const zod_1 = __importDefault(require("zod"));
const parsers_1 = require("../user/parsers");
const parsers_2 = require("../payoutMethod/parsers");
const parsers_3 = require("../currencies/parsers");
const parsers_granularity_1 = require("./parsers.granularity");
const parsers_4 = require("../utils/parsers");
const makeCompositeKeyParsers = (originTypeParser) => ({
    userId: parsers_1.userIdParser,
    originType: originTypeParser,
    currency: parsers_3.currencyParser,
});
exports.compositeKeyParsers = makeCompositeKeyParsers(parsers_2.payoutMethodOriginTypeParser);
exports.compositeKeyLineGranularParsers = makeCompositeKeyParsers(parsers_granularity_1.payoutMethodOriginTypeLineGranularParser);
exports.compositeKeyNonLineGranularParsers = makeCompositeKeyParsers(parsers_granularity_1.payoutMethodOriginTypeNonLineGranularParser);
exports.payoutBatchItemCompositeKeyParser = zod_1.default.object(exports.compositeKeyParsers);
exports.payoutBatchItemCompositeKeyLineGranularParser = zod_1.default.object(exports.compositeKeyLineGranularParsers);
exports.payoutBatchItemCompositeKeyNonLineGranularParser = zod_1.default.object(exports.compositeKeyNonLineGranularParsers);
exports.payoutBatchKeyParser = parsers_4.nonEmptyStringParser.transform((s) => s);
