"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.massPaypalPayoutItemNoteParser = exports.payoutBatchItemCompositeKeyNonLineGranularSerializedParserSafeParse = exports.payoutBatchItemCompositeKeyLineGranularSerializedParserSafeParse = exports.payoutBatchNonLineableItemCompositeKeySerializedParser = exports.payoutBatchLineableItemCompositeKeySerializedParser = exports.payoutBatchItemCompositeKeySerializedParser = void 0;
const zod_1 = __importDefault(require("zod"));
const isomorphism_1 = require("./isomorphism");
const parsers_common_1 = require("./parsers.common");
const string_1 = require("../utils/string");
const makePayoutBatchItemCompositeKeySerializedParser = (isomorphism, parser) => zod_1.default
    .string()
    .min(Object.keys(parsers_common_1.compositeKeyParsers).length +
    (Object.keys(parsers_common_1.compositeKeyParsers).length - 1) /*at least 1 letter separator is assumed*/)
    .transform((s, ctx) => {
    try {
        return isomorphism.from(s);
    }
    catch (e) {
        // zod error
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        if (e?.issues?.length) {
            const ze = e;
            ze.issues.forEach(ctx.addIssue.bind(ctx));
            return;
        }
        throw e;
    }
})
    .superRefine((o, ctx) => {
    const r = parser.safeParse(o);
    if (!r.success)
        r.error.issues.forEach(ctx.addIssue.bind(ctx));
})
    .transform((r) => {
    if (!r)
        throw new Error("panic! empty transform argument shouldn't happen here as it was reported as an error in a previous call");
    return isomorphism.to(r);
});
exports.payoutBatchItemCompositeKeySerializedParser = makePayoutBatchItemCompositeKeySerializedParser(isomorphism_1.payoutBatchItemCompositeKeyIsomorphism, parsers_common_1.payoutBatchItemCompositeKeyParser);
exports.payoutBatchLineableItemCompositeKeySerializedParser = makePayoutBatchItemCompositeKeySerializedParser(isomorphism_1.payoutBatchItemCompositeKeyLineableIsomorphism, parsers_common_1.payoutBatchItemCompositeKeyLineGranularParser);
exports.payoutBatchNonLineableItemCompositeKeySerializedParser = makePayoutBatchItemCompositeKeySerializedParser(isomorphism_1.payoutBatchItemCompositeKeyNonLineableIsomorphism, parsers_common_1.payoutBatchItemCompositeKeyNonLineGranularParser);
const payoutBatchItemCompositeKeyLineGranularSerializedParserSafeParse = (s) => exports.payoutBatchLineableItemCompositeKeySerializedParser.safeParse((0, string_1.assertStringStrict)(s));
exports.payoutBatchItemCompositeKeyLineGranularSerializedParserSafeParse = payoutBatchItemCompositeKeyLineGranularSerializedParserSafeParse;
const payoutBatchItemCompositeKeyNonLineGranularSerializedParserSafeParse = (s) => exports.payoutBatchNonLineableItemCompositeKeySerializedParser.safeParse((0, string_1.assertStringStrict)(s));
exports.payoutBatchItemCompositeKeyNonLineGranularSerializedParserSafeParse = payoutBatchItemCompositeKeyNonLineGranularSerializedParserSafeParse;
exports.massPaypalPayoutItemNoteParser = zod_1.default.string().regex(RegExp(isomorphism_1.paypalMassPayoutLineNoteFullRegexS));
