"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeSplitParser = void 0;
const zod_1 = __importDefault(require("zod"));
const constants_1 = require("../channel/constants");
const parsers_1 = require("../collective/parsers");
const parsers_id_1 = require("../blog/parsers.id");
const splitParserCommons = zod_1.default.object({
    activationThreshold: zod_1.default.number().int().min(0).optional(),
    blogs: zod_1.default.array(parsers_id_1.blogIdParser).default([]),
    collectives: zod_1.default.array(parsers_1.collectiveIdParser).default([]),
});
exports.makeSplitParser = {
    [constants_1.BLOG]: splitParserCommons,
    [constants_1.COLLECTIVE]: zod_1.default
        .object({
        blogs: zod_1.default.array(parsers_id_1.blogIdParser),
    })
        .merge(splitParserCommons),
    [constants_1.MIXSPACE]: splitParserCommons,
};
