"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.subscriptionDeleteParamsParser = exports.subscriptionUpdateResponseParser = exports.subscriptionUpdateParamsParser = exports.subscriptionUpdateInputParser = exports.subscriptionCreateResponseParser = exports.subscriptionCreateInputParser = exports.subscriptionOriginTypeParser = exports.subscriptionRecurringAndStatusParser = exports.subscriptionApiRecurringParser = exports.subscriptionStatusParser = exports.subscriptionRecurringParser = exports.subscriptionGetOneParamsParser = exports.subscriptionListResponseParser = exports.subscriptionListQueryParser = void 0;
const zod_1 = __importDefault(require("zod"));
const constants_1 = require("./constants");
const types_1 = require("../utils/types");
const parsers_1 = require("../stripe/parsers");
const parsers_2 = require("../payin/parsers");
const constants_2 = require("../payin/constants");
exports.subscriptionListQueryParser = parsers_2.payinListQueryParser;
exports.subscriptionListResponseParser = zod_1.default.any( /*stub*/).transform((r) => r);
exports.subscriptionGetOneParamsParser = zod_1.default.object({
    [constants_1.SUBSCRIPTION_ID_PARAM_NAME]: parsers_1.stripeSubscriptionIdParser,
});
exports.subscriptionRecurringParser = zod_1.default.boolean();
exports.subscriptionStatusParser = zod_1.default.enum(constants_1.SUBSCRIPTION_STATUSES);
exports.subscriptionApiRecurringParser = zod_1.default.object({
    recurring: exports.subscriptionRecurringParser,
});
exports.subscriptionRecurringAndStatusParser = zod_1.default
    .object({
    status: exports.subscriptionStatusParser,
})
    .merge(exports.subscriptionApiRecurringParser);
exports.subscriptionOriginTypeParser = zod_1.default.enum(constants_2.PAYIN_ORIGIN_TYPES);
// "api" subscription shape; not for use to parse real stripe subscriptions
exports.subscriptionCreateInputParser = zod_1.default
    .object({
// // TODO camelcase; used?
// origin_type: subscriptionOriginTypeParser,
// // TODO camelcase; used?
// origin_id: subscriptionOriginIdParser,
})
    .merge(parsers_2.payinApiSrcDstCompositeParser)
    .merge(parsers_2.payinAmountUnitParser)
    .merge(exports.subscriptionApiRecurringParser);
exports.subscriptionCreateResponseParser = zod_1.default.any( /*stub*/).transform((0, types_1.cast)());
exports.subscriptionUpdateInputParser = parsers_2.payinApiAmountParser.partial();
exports.subscriptionUpdateParamsParser = exports.subscriptionGetOneParamsParser;
exports.subscriptionUpdateResponseParser = exports.subscriptionCreateResponseParser;
exports.subscriptionDeleteParamsParser = exports.subscriptionGetOneParamsParser;
