"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tipFetchQueryParser = exports.tipParamsParser = exports.tipCreateResponseParser = exports.tipCreateInputParser = exports.tipOriginTypeParser = exports.tipListResponseParser = exports.tipListQueryParser = void 0;
const zod_1 = __importDefault(require("zod"));
const types_1 = require("../utils/types");
const parsers_1 = require("../payin/parsers");
const parser_1 = require("../idempotency/parser");
const constants_1 = require("../payin/constants");
const parsers_common_1 = require("../payin/parsers.common");
const parsers_2 = require("../parsers");
exports.tipListQueryParser = parsers_1.payinListQueryParser;
exports.tipListResponseParser = zod_1.default.any( /*stub*/).transform((0, types_1.cast)());
// export const tipStatusParser = z.enum(TipStatus);
exports.tipOriginTypeParser = parsers_common_1.payinOriginTypeParser;
const tipCreateCommonParser = zod_1.default
    .object({})
    .merge(parsers_1.payinAmountUnitParser)
    .merge(parsers_1.payinContextParser)
    .merge(parser_1.idempotencyKeyBodyParser);
// "api" tip shape; not for use to parse real stripe tips
exports.tipCreateInputParser = zod_1.default.object({}).merge(parsers_1.payinApiSrcDstCompositeParser).merge(tipCreateCommonParser);
exports.tipCreateResponseParser = zod_1.default.any( /*stub*/).transform((0, types_1.cast)());
exports.tipParamsParser = zod_1.default.object({
    [constants_1.PAYIN_KEY_PARAM_NAME]: parsers_1.payinSerializedKeyParser,
});
exports.tipFetchQueryParser = zod_1.default.object({
    bump: parsers_2.booleanQueryParser,
});
// export const tipUpdateInputParser = tipApiAmountParser.partial();
// export const tipUpdateParamsParser = tipGetOneParamsParser;
// export const tipUpdateResponseParser = tipCreateResponseParser;
// export const tipDeleteParamsParser = tipGetOneParamsParser;
