import {
  payinApiDstCompositeParser,
  payinApiDstSerializedParser,
  payinApiSrcCompositeParser,
  payinApiSrcSerializedParser,
} from './parsers.common';

describe('common parsers', () => {
  describe('id parsers', () => {
    it('should parse valid complext ids', () => {
      const src = 'user::123';
      const dst = 'channel::456';
      const srcSerializedParsed = payinApiSrcSerializedParser.parse(src);
      const dstSerializedParsed = payinApiDstSerializedParser.parse(dst);
      expect(srcSerializedParsed).toBe(src);
      expect(dstSerializedParsed).toBe(dst);
      const srcO = payinApiSrcCompositeParser.parse(src);
      const dstO = payinApiDstCompositeParser.parse(dst);
      expect(srcO).toEqual({
        type: 'user',
        id: '123',
      });
      expect(dstO).toEqual({
        type: 'channel',
        id: '456',
      });
    });
  });
});
